<?php
/**
* @project    Atom-M CMS
* @package    Authorization
* @url        http://atom-m.net
*/



header('Content-Type: text/html; charset=utf-8');

$Register = Register::getInstance();


$FpsDB = getDB();
$ACL = Register::getClass('ACL');



if (ADM_REFER_PROTECTED == 1) {
	$script_name = (!empty($_SERVER['REQUEST_URI'])) ? $_SERVER['REQUEST_URI'] : '';
	$script_name = strrchr($script_name, '/');
	if ($script_name != '/index.php') {
		$referer = (!empty($_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : '';
		preg_match('#^http://([^/]+)#', $referer, $match);
		if (empty($match[1]) || $match[1] != $_SERVER['SERVER_NAME'])
			redirect('/admin/index.php');
	}
}


if (Config::read('active', 'users') and !isset($_SESSION['user']['name'])) redirect('/');
if (!isset($_SESSION['adm_panel_authorize']) || $_SESSION['adm_panel_authorize'] < time() || empty($_SESSION['user'])) {
    if (isset($_POST['send']) && isset($_POST['passwd'])) {
        $errors = '';

        // Защита от перебора пароля - при каждой неудачной попытке время задержки увеличивается
        if (isset($_SESSION['count']) && $_SESSION['count'] > time()) {
            $errors .= '<li>' . sprintf(__('You must wait'), ($_SESSION['count'] - time())) . '</li>';
        }

        $pass = trim($_POST['passwd']);

        if (empty($pass)) $errors .= '<li>' . sprintf(__('Empty field "param"'), __('Password')) . '</li>';

        // Проверять существование такого пользователя есть смысл только в том
        // случае, если поля не пустые и не содержат недопустимых символов
        if (empty($error)) {
            $users = $FpsDB->select('users', DB_FIRST, array('cond' => array('name' => $_SESSION['user']['name'])));

            $check_password = false;
            if (count($users) > 0 && !empty($users[0])) {
                $check_password = checkPassword($users[0]['passw'], $pass);
            }

            if (count($users) < 1 || !$check_password) {
                $errors .= '<li>' . __('Wrong pass') . '</li>';
            } else {
                //turn access
                $ACL->turnUser(array('__panel__', 'entry'),true,array($users[0]['status'],$users[0]['id']));
            }
        }

        // Если были допущены ошибки при заполнении формы
        if (!empty($errors)) {
            if (!isset($_SESSION['count']))
                $_SESSION['count'] = 1;
            else if ($_SESSION['count'] < 10)
                $_SESSION['count']++;
            else if ($_SESSION['count'] < time())
                $_SESSION['count'] = time() + 10;
            else
                $_SESSION['count'] = $_SESSION['count'] + 10;
        }

        if (empty($errors)) {
            $_SESSION['user'] = $users[0];
            $_SESSION['adm_panel_authorize'] = (time() + Config::read('session_time', '__secure__'));
            redirect($_SERVER['REQUEST_URI']);
        }
    }


    $pageTitle = __('Atom-M Admin Panel Authorization');
    $pageNav = '';
    $pageNavr = '';
?>



<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php echo __('Atom-M Admin Panel Authorization') ?></title>
	<meta name="description" content="" />
	<meta name="keywords" content="" />
	<meta content="text/html; charset=UTF-8" http-equiv="Content-Type" />
	<link rel="StyleSheet" type="text/css" href="<?php echo WWW_ROOT ?>/admin/template/css/style.css" />
	<script language="JavaScript" type="text/javascript" src="<?php echo WWW_ROOT ?>/data/js/jquery.js"></script>
	<script type="text/javascript">
	</script>
</head>
<body>
	<div id="login-wrapper">
		<div class="form">
			<div class="title"><?php echo __('Please retype the password') ?></div>
			<form method="POST" action="" >
				<div class="items">
					<?php 
					if (!empty($errors)) {
						echo '<ul class="error">' . $errors . '</ul>';
						unset($errors);
					}
					?>
					<div class="item"><span><?php echo __('Password') ?></span><input name="passwd" type="password" /></div>
				</div>
                <br/><br/>
                <div style="text-align:center"><input class="save-button" type="submit" name="send" value="<?php echo __('Sign in') ?>" /></div>
			</form>
		</div>
	</div>
</body>
</html>






<?php
	die();

	
	
} else if (!empty($_SESSION['adm_panel_authorize'])) {
	$_SESSION['adm_panel_authorize'] = (time() + Config::read('session_time', '__secure__'));
	
	if ($ACL->turnUser(array('__panel__', 'restricted_access'))) {
	
		$url = preg_replace('#^.*/([^/]+)\.\w{2,5}$#i', "$1", $_SERVER['SCRIPT_NAME']);
		//var_dump($url);
		if (!empty($url) && $url != 'index') {
			if (!$ACL->turnUser(array('__panel__', 'restricted_access_' . $url))) {
				$_SESSION['message'] = __('Permission denied');
				redirect('/admin/');
			}
		}
	}
}






if (!empty($_GET['install'])) {
	$instMod = (string)$_GET['install'];
	if (!empty($instMod) && preg_match('#^[a-z]+$#i', $instMod)) {
        $ModulesInstaller = new ModuleInstaller();
		$ModulesInstaller->installModule($instMod);
        redirect('/admin/');
	}
}



function getAdmFrontMenuParams() {
    $ModulesInstaller = new ModuleInstaller();
    $out = array();
    $modules = glob(ROOT . '/modules/*', GLOB_ONLYDIR);
    
    if (count($modules)) {
        foreach ($modules as $i => $modPath) {
            $mod = basename($modPath);
            if (!$ModulesInstaller->checkModule($mod)) {
                $menuPath = $modPath . '/menu.php';
                if (file_exists($menuPath)) {
                    include($menuPath);
                    if (isset($menuInfo)) {
                        $out[$mod] = $menuInfo;
                    }
                }
                if (!isset($out[$mod])) {
                    $out[$mod] = array(
                        'url'   => WWW_ROOT.'/admin/settings.php?m='.$mod,
                        'ankor' => __($mod,false,$mod),
                    );
                }
            }
        }
    }
	uasort($out, function ($a, $b) {
        if (is_array($a) && is_array($b) && isset($a['ankor']) && isset($b['ankor'])) {
            if ($a['ankor'] == $b['ankor']) {
                return 0;
            }
            return ($a['ankor'] < $b['ankor']) ? -1 : 1;
        } else {
            return 0;
        }
    });
    return $out;
}
?>