<?php
/**
* @project    Atom-M CMS
* @package    Editor templates for mail
* @url        http://atom-m.net
*/



include_once R.'admin/inc/adm_boot.php';
$pageTitle = __('Editing mail templates');
$Register = Register::getInstance();

$url_to_dir = ROOT . '/data/mail/' . Config::read('users.mail_template');
$dir = opendir($url_to_dir);
$i = 1;
$good = false;
while ($file = readdir($dir)) { // проход по файлам в директории выбранного шаблона писем
    if (substr($file, -4) == '.msg') { // встречаем файл с расширением .msg
        $tmp[$i] = substr($file, 0, -4); // отрезаем расширение .msg у названия файла

        $url_to_file = $url_to_dir . '/' . $tmp[$i] . '.msg'; // формируем ссылку на файл

        if (isset($_POST['tmp_mail_' . $tmp[$i]])) {// если запрос существует
            $post = $_POST['tmp_mail_' . $tmp[$i]]; // считываем нужный POST запрос в переменную
            @file_put_contents($url_to_file, $post); // записываем в файл
            $good = true; // Информируем пользователя, что все хорошо
        }
        $tmp_code[$i] = @file_get_contents($url_to_file); // читаем содержимое файла

        $i++; // переходим к следующему файлу
    }
}
closedir($dir);

$pageNav = $pageTitle;
$pageNavr = '';
include_once R.'admin/template/header.php';

if ($good) {
    echo '<div class="warning"><br /><b>' . __('Template edited') . '</b><br /><br /></div>';
}
?>
<form method="POST" action="mail_tmp.php" enctype="multipart/form-data">
<div class="list">
    <div class="title"><?php echo $pageTitle . ' (' . Config::read('users.mail_template') . ') '; ?></div>
    <div class="level1">
        <div class="head">
            <div class="title settings"><?php echo __('Name') ?></div>
            <div class="title-r"><?php echo __('Value') ?></div>
            <div class="clear"></div>
        </div>
        <div class="items">
        <?php
        for ($i = 1; $i <= count($tmp); $i++) {


             $output  = '<div class="setting-item"><div class="left">';
             $output .= __('mail_tmp_' . $tmp[$i]); // название и комментарий ключа
             $output .= '</div>
                             <div class="right">';
             $output .= '<textarea wrap="off" name="tmp_mail_' . $tmp[$i] . '">' . $tmp_code[$i] . '</textarea>'; // поле редактирования шаблона
             $output .= '</div>
                                <div class="clear"></div>
                         </div>';


                echo $output;
        }
        ?>
            <div class="setting-item">
                <div class="left"></div>
                <div class="right">
                    <input class="save-button" type="submit" value="<?php echo __('Save') ?>" />
                </div>
                <div class="clear"></div>
                <style>
                .right textarea {height:200px;width:505px}
                </style>
            </div>
        </div>
    </div>
</div>
</form>

<ul class="markers">
    <h2><?php echo __('Markers for mail templates') ?></h2>
    <li><div class="global-marks">{{ fps_server_name }}</div> - <?php echo __('Domain your site') ?></li>
    <li><div class="global-marks">{{ site_title }}</div> - <?php echo __('Name your site') ?></li>
    <li><div class="global-marks">{{ mail.name }}</div> - <?php echo __('Login new user') ?></li>
    <li><div class="global-marks">{{ mail.password }}</div> - <?php echo __('Password user') ?></li>
    <li><div class="global-marks">{{ mail.link }}</div> - <?php echo __('Link on activation page') ?></li>
    <li><div class="global-marks">{{ fps_date }}</div> - <?php echo __('Date of sanding message') ?></li>
    <li><div class="global-marks">{{ fps_time }}</div> - <?php echo __('Time of sanding message') ?></li>
    <li><div class="global-marks">{{ context }}</div> - <?php echo __('Mail context') ?></li>
    <li><div class="global-marks">{{ from.name }}</div> - <?php echo __('From name') ?></li>
    <li><div class="global-marks">{{ mail.subject }}</div> - <?php echo __('Message from name') ?></li>
</ul>

<?php include_once R.'admin/template/footer.php'; ?>