<?php

if (!isset($usec) && !isset($sec))
    list($usec, $sec) = explode(" ", microtime());

session_start();
if (isset($_SESSION['db_querys'])) unset($_SESSION['db_querys']);

// Назначение дефолтной временной зоны, чтобы подсчеты велись так как надо.
date_default_timezone_set('UTC');

/**
 * Current version of engine
 */
define('ATOM_VERSION', '4 (8.01.2015)');

/**
 * Path constants
 */
define('ROOT', dirname(dirname(__FILE__)));
define ('DS', DIRECTORY_SEPARATOR);
define ('R', dirname(dirname(__FILE__)) . DS);


/**
 * If we uses Fapos from subdir or subdirs
 * we must set this variable, because Fapos
 * must know this for good work.
 */
define ('WWW_ROOT', substr(ROOT , mb_strlen($_SERVER['DOCUMENT_ROOT'], 'utf-8')));
/**
 * If set to 1, check referer in admin panel
 * and if he dont match current host redirect to
 * index page of admin panel. It doesn't allow to
 * send inquiries from other hosts.
 */
define ('ADM_REFER_PROTECTED', 0);






/**
 * whether the system is installed
 */
function isInstall() {
    return !file_exists(ROOT . '/install');
}


/**
 * Autoload
 */
// Загружает класс, если он еще не был загружен при его непосредственном вызове
spl_autoload_register(function($class) {

    /*if ('Fps_Viewer' !== substr($class, 0, strlen('Fps_Viewer'))) {
        $class = strtolower($class);
    }*/


    // ORM elements must located in module directory or in /sys/inc/ORM/ directory 
    // Freedom for users and developers ;)
    if ('Entity' === mb_substr($class, -6)) {
        $module = preg_split("/\B[A-Z]+/", $class);
        $module = strtolower($module[0]);
        $_class = str_replace('Entity', '', $class);
        if (file_exists(ROOT . '/modules/' . $module . '/ORM/Entities/' . $_class . '.php')) {
            include_once ROOT . '/modules/' . $module . '/ORM/Entities/' . $_class . '.php';
            return true;
        } else if (file_exists(ROOT . '/sys/inc/ORM/Entities/' . $_class . '.php')) {
            include_once ROOT . '/sys/inc/ORM/Entities/' . $_class . '.php';
            return true;
        }
    } else if ('Model' === mb_substr($class, -5)) {
        $module = preg_split("/\B[A-Z]+/", $class);
        $module = strtolower($module[0]);
        $_class = str_replace('Model', '', $class);
        if (file_exists(ROOT . '/modules/' . $module . '/ORM/Models/' . $_class . '.php')) {
            include_once ROOT . '/modules/' . $module . '/ORM/Models/' . $_class . '.php';
            return true;
        } else if (file_exists(ROOT . '/sys/inc/ORM/Models/' . $_class . '.php')) {
            include_once ROOT . '/sys/inc/ORM/Models/' . $_class . '.php';
            return true;
        }
    }


    // Other classes must located in /sys/inc/ 
    if (file_exists(ROOT . '/sys/inc/' . strtolower($class) . '.class.php')) {
        include_once ROOT . '/sys/inc/' . strtolower($class) . '.class.php';
        return true;
    } else if (file_exists(ROOT . '/sys/inc/' . $class . '.class.php')){
        include_once ROOT . '/sys/inc/' . $class . '.class.php';
        return true;
    }
    
    
    // Include FpsViewer files
    if ('Fps_Viewer' === substr($class, 0, strlen('Fps_Viewer'))) {
        $file = ROOT . '/sys/inc/' . strtr($class, array('_' => '/', 'Fps_' => '')) . '.class.php';
        if (file_exists($file)) {
            include_once $file;
            return true;
        }
    }

});


function loadFuncs() {
    $files = glob(ROOT . '/sys/fnc/*.php');
    if (count($files)) {
        foreach ($files as $file) {
            include_once $file;
        }
    }
}
loadFuncs();


/**
 * Registry
 */
$Register = Register::getInstance();
/**  TOUCH START TIME */
$Register['fps_boot_start_time'] = ((float)$usec + (float)$sec);
/** /TOUCH START TIME */

$Register['Config'] = new Config(ROOT . '/sys/settings/config.php');



/**  SET PHP SETTINGS */
@ini_set('session.gc_maxlifetime', 10000);
ini_set('post_max_size', "100M");
ini_set('upload_max_filesize', "100M");
if (function_exists('set_time_limit')) @set_time_limit(200);
ini_set('register_globals', 0);
ini_set('magic_quotes_gpc', 0);
ini_set('magic_quotes_runtime', 0);
session_set_cookie_params(3000);
ini_set('display_errors', 0);
error_reporting(E_ALL & ~E_NOTICE);

/** if debug mode On - view errors */
if (Config::read('debug_mode') == 1) {
    ini_set('display_errors', 1);
    error_reporting(E_ALL);
}

ini_set('upload_max_filesize', '100M');
ini_set('post_max_size', '100M');
ini_set('log_errors', 1);
ini_set('error_log', ROOT . '/sys/logs/php_errors.log');

/**
 * Set default encoding
 * After set this, we mustn't set encoding
 * into next functions: mb_substr, mb_strlen, etc...
 */
if (function_exists('mb_internal_encoding'))
    mb_internal_encoding('UTF-8');

/** /SET PHP SETTINGS */


/** FINAL LOADING */
if (isInstall()) {

    if (get_magic_quotes_gpc()) {
      strips($_GET);
      strips($_POST);
      strips($_COOKIE);
      strips($_REQUEST);
      if (isset($_SERVER['PHP_AUTH_USER'])) strips($_SERVER['PHP_AUTH_USER']);
      if (isset($_SERVER['PHP_AUTH_PW']))   strips($_SERVER['PHP_AUTH_PW']);
    }
    
    Register::getClass('Plugins');
    
    /** Secure checking */
    Register::getClass('Protect')->checkIpBan();
    if (Config::read('anti_ddos', '__secure__') == 1) $Register['Protect']->antiDdos();
    if (Config::read('antisql', '__secure__') == 1) $Register['Protect']->antiSQL();
    
    if (Config::read('__secure__.system_log'))
        Register::getClass('Logination');
    
    Register::getClass('UserAuth');
    if (!isset($_SESSION['user']['name'])) {
        /*
        * Auto login... if user during a previos
        * visit set AUTOLOGIN option
        */
        if (isset($_COOKIE['autologin']))
            $Register['UserAuth']->autoLogin();
    
        /*
        * if user is autorizet set
        * last time visit
        * This information store in <DataBase>.users
        */
        $Register['UserAuth']->setTimeVisit();
    }

}




