<?php
/**
* @project    Atom-M CMS
* @package    Comments Entity
* @url        http://atom-m.net
*/



/**
 *
 */
class CommentsEntity extends FpsEntity
{
    protected $id;
    protected $parent_id;
    protected $entity_id;
    protected $user_id;
    protected $name;
    protected $message;
    protected $ip;
    protected $mail;
    protected $date;
    protected $editdate;
    protected $module;
    protected $premoder;
    protected $add_fields = null;


    public function save()
    {
        $data = array(
            'parent_id' => intval($this->parent_id),
            'entity_id' => intval($this->entity_id),
            'user_id' => intval($this->user_id),
            'name' => $this->name,
            'message' => $this->message,
            'ip' => $this->ip,
            'mail' => $this->mail,
            'date' => $this->date,
            'editdate' => $this->editdate,
            'module' => $this->module,
            'premoder' => (!empty($this->premoder) && in_array($this->premoder, array('nochecked', 'rejected', 'confirmed'))) ? $this->premoder : 'nochecked',
        );

        if (is_array($this->add_fields))
            foreach ($this->add_fields as $k => $value)
                $data['add_field_'.$k] = $value;

        if($this->id) $data['id'] = $this->id;

        return (getDB()->save('comments', $data));
    }


    public function delete()
    {
        getDB()->delete('comments', array('id' => $this->id));
    }

    public function __getAPI() {

        $ACL = Register::getClass('ACL');
        if (
            !$ACL->turnUser(array($this->module, 'view_list')) ||
            !$ACL->turnUser(array($this->module, 'view_materials'))
        )
            return array();

        $add_fields = array();
        if (is_array($this->add_fields))
            foreach ($this->add_fields as $k => $value)
                $add_fields['add_field_'.$k] = $value;

        return array_merge(array(
            'id' => $this->id,
            'parent_id' => $this->parent_id,
            'entity_id' => $this->entity_id,
            'user_id' => $this->user_id,
            'name' => $this->name,
            'message' => $this->message,
            'ip' => $this->ip,
            'mail' => $this->mail,
            'date' => $this->date,
            'editdate' => $this->editdate,
            'module' => $this->module,
            'premoder' => $this->premoder,
        ), $add_fields);
    }
}