<?php
/**
* @project    Atom-M CMS
* @package    Validate class
* @url        http://atom-m.net
*/


/*
 * REGEX for titles.
 * Allowed chars. You can change this.
 */
//define ('V_TITLE', '#^[A-ZА-Яа-яa-z0-9\s-\(\),\._\?\!\w\d\{\} ]+$#ui');
define ('V_TITLE', '#^[A-ZА-Яа-яa-z0-9ё\s\-(),._\?!\w\d\{\}\<\>:=\+&%\$\[\]\\\/"\']+$#ui');
define ('V_TITLE_NOHTML', '#^[A-ZА-Яа-яa-z0-9ё\s\-(),._\?!\w\d\{\}:=\+&%\$\[\]\\\/"\']+$#ui');


define ('V_INT', '#^\d+$#i');
define ('V_TEXT', '#^[\wA-ZА-Яа-яa-z0-9\s\-\(\):;\[\]\+!\.,&\?/\{\}="\']*$#uim');
define ('V_MAIL', '#^[0-9a-z_\-\.]+@[0-9a-z\-\.]+\.[a-z]{2,6}$#i');
define ('V_URL', '#^((https?|ftp):\/\/)?(www.)?([0-9a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюя]+(-?[0-9a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюя]+)*\.)+[a-zабвгдеёжзийклмнопрстуфхцчшщъыьэюя]{2,6}(\/[+-\w\d=_.%\?&\/]*)*$#i');
define ('V_CAPTCHA', '#^[\dabcdefghijklmnopqrstuvwxyz]+$#i');
define ('V_LOGIN', '#^[- _0-9A-Za-zА-Яа-я@]+$#ui');
define ('V_LOGIN_LATIN', '#^[- _0-9A-Za-z@]+$#ui');
define ('V_FULLNAME', '#^[A-ZА-Яа-яa-zё\s\-(),.\D\']+$#ui');
define ('V_CITY', '#^[- _a-zА-Яа-я@]+$#ui');

class Validate {



    public static function getCurrentInputsValues($entity, $pattern = array())
    {
        $session = array();

        if (empty($pattern) && is_array($entity)) $pattern = $entity;
        foreach ($pattern as $key => $value) {

            if (is_object($entity)) {
                $getter = 'get' . ucfirst($key);
                $setter = 'set' . ucfirst($key);
                if (isset($session[$key])) {
                    $entity->$setter($session[$key]);
                } else if (!$entity->$getter()) {
                    $entity->$setter($value);
                }
            } else if (is_array($entity)) {
                if (isset($session[$key])) {
                    $entity[$key] = $session[$key];
                } else if (!isset($entity[$key])) {
                    $entity[$key] = $value;
                }
            }
        }
        return $entity;
    }


    public function cha_val ($data, $filter = '#^\w*$#Uim') {
        if (!preg_match($filter, $data)) return false;
        else return true;
    }


    public function len_val ($data, $min = 1, $max = 100) {

        if (mb_strlen($data) > $max) return __('Very long value');
        elseif (mb_strlen($data) < $min) return __('Very short value');

        return true;
    }


    //find similar records from  $sourse (< array(table, field) >)
    // TODO || Delete
    public function uniq_val($data, $sourse, $type = 'low') {
        $Register = Register::getInstance();
        global $FpsDB;
        if ($type == 'hight') {
            //array with russian letters
            $rus = array( "А","а","В","Е","е","К","М","Н","О","о","Р","р","С","с","Т","Х","х" );
            // array with latinic letters
            $eng = array( "A","a","B","E","e","K","M","H","O","o","P","p","C","c","T","X","x" );
            // change russian to latinic
            $eng_new_data = str_replace($rus, $eng, $data);
            // change latinic to russian
            $rus_new_data = str_replace($eng, $rus, $data);

            $table = getDB()->getFullTableName($sourse['table']);

            // create SQL query
            $sql = "SELECT * FROM `{$table}`
                    WHERE `{$sourse['field']}` LIKE '".getDB()->escape( $data )."' OR
                    `{$sourse['field']}` LIKE '".getDB()->escape( $eng_new_data )."' OR
                    `{$sourse['field']}` LIKE '".getDB()->escape( $rus_new_data )."'";

        } else { //security level not hight...

            $sql = "SELECT COUNT(*)
                    FROM `{$table}`
                    WHERE `{$sourse['field']}` LIKE '" . getDB()->escape($data) . "'";

        }
        $query = getDB()->query($sql);

        return (count($query) > 0) ? false : true;
    }

}

?>
