<?php



class Fps_Viewer_Node_Function
{

    private $func;
    private $params;
    static $AllowFunctions;


    public function __construct($func, $params = array())
    {
        if (empty(self::$AllowFunctions)) self::$AllowFunctions = include(R.'sys/inc/Viewer/AllowFnc.php');
        if (!in_array($func,self::$AllowFunctions)) throw new Exception("Function $func is not available for use in the Viewer");
        $this->func = $func;
        $this->params = $params;
    }


    public function addParam($node) {
        array_push($this->params, $node);
    }


    public function compile(Fps_Viewer_CompileParser $compiler)
    {
        $compiler->raw("$this->func(");
        while (count($this->params) > 0) {
            $node = array_shift($this->params);
            $compiler->raw($node->compile($compiler));
            if (count($this->params) > 0) $compiler->raw(", ");
        }
        $compiler->raw(")");
    }


    public function __toString()
    {
        $out = '[function_name]:' . $this->func . "\n";
        $out .= '[params]:' . implode("<br>\n", $this->params) . "\n";
        return $out;
    }
}